<template>
  <div
    :id="product.slug"
    class="relative flex flex-col items-center justify-between p-3 product group"
  >
    <div
      class="transition-all duration-300 ease-in-out bg-white border-2 border-transparent rounded shadow-lg hover:border-primary-100 hover:shadow-xl"
    >
      <!-- Media -->
      <div
        class="relative flex items-center justify-center w-full h-full transition-all duration-100 ease-in-out media"
      >
        <nuxt-link
          :to="{
            name: 'shop-slug',
            params: { slug: product.slug, productType: product.type },
          }"
          class="w-full h-full"
        >
          <img
            v-lazy="product.productImages.image"
            class="object-contain object-center w-full h-full"
            :alt="product.name"
            loading="lazy"
          />
        </nuxt-link>
        <!-- Discount -->
        <span
          v-if="product.onSale"
          class="absolute top-0 right-0 flex items-center justify-center w-12 h-12 mt-2 mr-2 text-sm font-bold text-white rounded-full shadow-md cursor-default bg-secondary-500"
          title="Product on sale"
        >
          {{ getDiscount(product.salePrice, product.regularPrice) }}%
        </span>

        <!-- Featured -->
        <span
          v-if="product.featured"
          class="absolute top-0 left-0 flex items-center justify-center w-12 h-12 mt-2 ml-2 text-sm font-bold text-white bg-transparent rounded-full"
          title="Featured product"
        >
          <i class="text-2xl bx bxs-star" style="color: yellow"></i>
        </span>
      </div>

      <!-- Body -->
      <div
        class="flex items-center justify-between w-full p-3 body flex-column"
        style="min-height: 100px"
      >
        <div class="grid w-full grid-cols-3">
          <div class="col-span-2">
            <nuxt-link
              :to="{
                name: 'shop-slug',
                params: { slug: product.slug, productType: product.type },
              }"
              class="hover:text-primary-400"
            >
              <h3 class="text-sm text-secondary-300" title="Product name">
                {{
                  product.name
                    .split(' - ')[1]
                    .replace(/--/g, '')
                    .replace(/_/g, ' ')
                }}
              </h3>
            </nuxt-link>
            <span class="text-base font-semibold" title="Brand">
              {{ product.name.split(' - ')[0] }}
            </span>
          </div>

          <div class="col-span-1 text-right">
            <h3
              v-if="!product.onSale"
              class="text-base font-semibold"
              title="Price"
            >
              US{{ product.price }}
            </h3>
            <h3 v-else class="text-base font-semibold">
              <del class="text-xs text-secondary-200" title="Regular price">
                US{{ product.regularPrice }}
              </del>
              <br />
              <span title="Sale price">US{{ product.salePrice }}</span>
            </h3>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    product: {
      type: Object,
      required: true,
    },
    index: {
      type: Number,
      required: false,
      default: 1,
    },
  },
  methods: {
    getDiscount(salePrice, regularPrice) {
      const offerPrice = parseFloat(salePrice.split('$')[1])
      const price = parseFloat(regularPrice.split('$')[1])

      // Discount
      return Math.round((offerPrice * 100) / price - 100)
    },
  },
}
</script>
